
import XEUtils from 'xe-utils'
var mixinMethod = {
  data () {
    return {
      searchQueryCtrlF: '',
      searchProps: ['sampleIdLims'],
      filterName: '',
      filterName1: '',
      currentIndex: 0,
      columnShow: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'storageName', 'positionInBox', 'originalSampleTypeName', 'pathologyCode', 'labCode', 'patientName', 'orderCancerTypeName', 'samplingLocation', 'sampleIdExternal', 'tumourCellRadio', 'tumourCellNecroLvl', 'receiveRemarks', 'stickNumber', 'labAssistantName', 'examingDateValue', 'diagnosisUserName', 'diagnosisDateValue', 'orderCode', 'taskId', 'taskStatusName', 'hePathologyCode', 'tpsRadio', 'cps', 'tcRadio', 'icRadio', 'icPlusRadio', 'pathologyAssessment', 'antibody', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'usedSampleAmt', 'nanodropConsistenceAmt', 'od260280', 'od260230', 'consistenceAmt', 'volumeAmt', 'totalAmt', 'extractedPerMlAmt', 'rinValue', 'dnaConcentration', 'dilutionFactor', 'dnaPollutionRate', 'positionInTmpBox', 'noOfRoundLabels', 'noOfLongLabels', 'actualConsistenceAmt', 'actualVolumeAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt', 'rnaIsPurification', 'condenseConsistenceAmt', 'condenseVolumeAmt', 'condenseTotalAmt', 'hydrateVolumeAmt', 'dnaConsistenceAmt', 'dnaVolumeAmt', 'dnaTotalAmt', 'purificationConsistenceAmt', 'purificationVolumeAmt', 'pcrUsedTotalAmt', 'loopNum', 'amplificationRatio', 'poolingName', 'sqcGroupNum', 'actualThroughput', 'estimatedSqcTime', 'instrumentName', 'preinstallLaneNum', 'seqReadLen', 'poolingRemarks', 'sgCq2', 'sgCq3', 'sgCqstddev', 'sgCqmean', 'sgThroughput', 'sgThroughputPercentage', 'sgFragmentLen', 'sgUsedMolarTotalAmt', 'sgMolarConcentration', 'sgUsedVolumeAmt', 'sgUsedTotalAmt', 'sgRemarks', 'originalConsistenceAmt', 'originalVolumeAmt', 'addedVolumeAmt', 'fragmentLen', 'molarConcentration', 'standardName', 'cq1', 'sgCq1', 'cq2', 'sgCq2', 'cq3', 'sgCq3', 'cqstddev', 'cqmean', 'amplificationEfficiency', 'indexName', 'preinstallThroughput', 'adjustedThroughput', 'poolingLoopNum', 'actualLoopNum', 'throughputPercentage', 'srRemarks', 'getRate', 'bloodLibRatio', 'ctdnaLibRatio', 'ffpeLibRatio', 'throughput', 'ftLibRatio', 'othersFragmentLen', 'experimenterName', 'poolingStartTotalAmt', 'actualFragmentLen', 'actualMolarConcentration', 'adjustedConcentrationRatio', 'indexSeqDigits', 'actualLaneNum', 'actualSeqTime', 'seqUsedVolumeAmt', 'ddpcrUsedVolumeAmt', 'ddpcrUsedTotalAmt', 'totalOilDrop', 'famSigOilDrop', 'hexSigOilDrop', 'resultAssessment'],
      stepSearchProps: {
        sampleProcessorSchedule: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'storageName', 'positionInBox', 'submittedByName', 'submittedByDate'],
        sampleProcessorResult: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'originalSampleTypeName', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'storageName', 'positionInBox', 'submittedByName', 'submittedByDate'],
        pathologyHeResult: ['pathologyCode', 'labCode', 'sampleIdLab', 'patientName', 'orderCancerTypeName', 'samplingLocation', 'sampleIdExternal', 'tumourCellRadio', 'tumourCellNecroLvl', 'remarks', 'receiveRemarks', 'stickNumber', 'labAssistantName', 'examingDateValue', 'diagnosisUserName', 'diagnosisDateValue', 'orderCode', 'taskId', 'sampleIdLims', 'taskStatusName'],
        pathologyPdlResult: ['pathologyCode', 'labCode', 'sampleIdLab', 'patientName', 'orderCancerTypeName', 'samplingLocation', 'sampleIdExternal', 'hePathologyCode', 'tumourCellRadio', 'tumourCellNecroLvl', 'tpsRadio', 'cps', 'tcRadio', 'icRadio', 'icPlusRadio', 'pathologyAssessment', 'antibody', 'remarks', 'receiveRemarks', 'stickNumber', 'labAssistantName', 'examingDateValue', 'diagnosisUserName', 'diagnosisDateValue', 'orderCode', 'taskId', 'sampleIdLims', 'taskStatusName'],
        extractionSchedule: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'submittedByName', 'submittedByDate'],
        extractionResults: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'originalSampleTypeName', 'sampleTypeName', 'usedSampleAmt', 'nanodropConsistenceAmt', 'od260280', 'od260230', 'consistenceAmt', 'volumeAmt', 'totalAmt', 'extractedPerMlAmt', 'rinValue', 'dnaConcentration', 'dilutionFactor', 'dnaPollutionRate', 'samplePkgAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'nextStepName', 'stoppedReason', 'submittedByName', 'submittedByDate', 'positionInTmpBox', 'noOfRoundLabels', 'noOfLongLabels', 'remarks'],
        ultrafracSchedule: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'consistenceAmt', 'actualConsistenceAmt', 'volumeAmt', 'actualVolumeAmt', 'totalAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt'],
        ultrafracResults: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'originalSampleTypeName', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'consistenceAmt', 'actualConsistenceAmt', 'volumeAmt', 'actualVolumeAmt', 'totalAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt', 'positionInTmpBox', 'rnaIsPurification', 'rinValue', 'condenseConsistenceAmt', 'condenseVolumeAmt', 'condenseTotalAmt', 'hydrateVolumeAmt', 'dnaConsistenceAmt', 'dnaVolumeAmt', 'dnaTotalAmt', 'purificationConsistenceAmt', 'purificationVolumeAmt', 'pcrUsedTotalAmt', 'loopNum', 'amplificationRatio', 'noOfRoundLabels', 'noOfLongLabels'],
        libconstructionSchedule: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'originalSampleTypeName', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'consistenceAmt', 'actualConsistenceAmt', 'volumeAmt', 'actualVolumeAmt', 'totalAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt', 'positionInTmpBox', 'rnaIsPurification', 'rinValue', 'condenseConsistenceAmt', 'condenseVolumeAmt', 'condenseTotalAmt', 'hydrateVolumeAmt', 'dnaConsistenceAmt', 'dnaVolumeAmt', 'dnaTotalAmt'],
        libconstructionResults: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'originalSampleTypeName', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'consistenceAmt', 'actualConsistenceAmt', 'volumeAmt', 'actualVolumeAmt', 'totalAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt', 'positionInTmpBox', 'rnaIsPurification', 'rinValue', 'condenseConsistenceAmt', 'condenseVolumeAmt', 'condenseTotalAmt', 'hydrateVolumeAmt', 'dnaConsistenceAmt', 'dnaVolumeAmt', 'dnaTotalAmt', 'purificationConsistenceAmt', 'purificationVolumeAmt', 'pcrUsedTotalAmt', 'loopNum', 'amplificationRatio', 'noOfRoundLabels', 'noOfLongLabels'],
        libquantSchedule: ['sortNo', 'sampleIdLims', 'poolingName', 'sqcGroupNum', 'actualThroughput', 'estimatedSqcTime', 'instrumentName', 'preinstallLaneNum', 'seqReadLen', 'sampleIdLab', 'poolingRemarks', 'originalSampleTypeName', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'consistenceAmt', 'actualConsistenceAmt', 'volumeAmt', 'actualVolumeAmt', 'totalAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt', 'positionInTmpBox', 'rnaIsPurification', 'rinValue', 'condenseConsistenceAmt', 'condenseVolumeAmt', 'condenseTotalAmt', 'hydrateVolumeAmt', 'dnaConsistenceAmt', 'dnaVolumeAmt', 'dnaTotalAmt', 'purificationConsistenceAmt', 'purificationVolumeAmt', 'pcrUsedTotalAmt', 'loopNum', 'amplificationRatio', 'noOfRoundLabels', 'noOfLongLabels', 'sgCq2', 'sgCq3', 'sgCqstddev', 'sgCqmean', 'sgThroughput', 'sgThroughputPercentage', 'sgFragmentLen', 'sgUsedMolarTotalAmt', 'sgMolarConcentration', 'sgUsedVolumeAmt', 'sgUsedTotalAmt', 'sgRemarks'],
        libquantResults: ['sortNo', 'sampleIdLims', 'poolingName', 'sqcGroupNum', 'originalConsistenceAmt', 'originalVolumeAmt', 'addedVolumeAmt', 'consistenceAmt', 'fragmentLen', 'molarConcentration', 'sampleIdLab', 'originalSampleTypeName', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'consistenceAmt', 'actualConsistenceAmt', 'volumeAmt', 'actualVolumeAmt', 'totalAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt', 'positionInTmpBox', 'rnaIsPurification', 'rinValue', 'condenseConsistenceAmt', 'condenseVolumeAmt', 'condenseTotalAmt', 'hydrateVolumeAmt', 'dnaConsistenceAmt', 'dnaVolumeAmt', 'dnaTotalAmt', 'purificationConsistenceAmt', 'purificationVolumeAmt', 'pcrUsedTotalAmt', 'loopNum', 'amplificationRatio', 'noOfRoundLabels', 'noOfLongLabels', 'standardName', 'cq1', 'cq2', 'cq3', 'cqstddev', 'cqmean', 'amplificationEfficiency'],
        enrichmentSchedule: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'poolingName', 'indexName', 'amplificationRatio', 'preinstallThroughput', 'adjustedThroughput', 'poolingLoopNum', 'actualLoopNum', 'throughputPercentage', 'actualThroughput', 'mergedSampleIdLims', 'sqcGroupNum', 'originalConsistenceAmt', 'originalVolumeAmt', 'originalSampleTypeName', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'consistenceAmt', 'actualConsistenceAmt', 'volumeAmt', 'actualVolumeAmt', 'totalAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt', 'positionInTmpBox', 'rnaIsPurification', 'rinValue', 'condenseConsistenceAmt', 'condenseVolumeAmt', 'condenseTotalAmt', 'hydrateVolumeAmt', 'dnaConsistenceAmt', 'dnaVolumeAmt', 'dnaTotalAmt', 'purificationConsistenceAmt', 'purificationVolumeAmt', 'pcrUsedTotalAmt', 'loopNum', 'amplificationRatio', 'noOfRoundLabels', 'noOfLongLabels'],
        enrichmentResults: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'poolingName', 'srRemarks', 'getRate', 'bloodLibRatio', 'ctdnaLibRatio', 'ffpeLibRatio', 'throughput', 'estimatedSqcTime', 'ftLibRatio', 'othersFragmentLen', 'instrumentName', 'seqReadLen', 'experimenterName', 'preinstallLaneNum', 'poolingStartTotalAmt', 'amplificationRatio', 'preinstallThroughput', 'adjustedThroughput', 'poolingLoopNum', 'actualLoopNum', 'throughputPercentage', 'actualThroughput', 'mergedSampleIdLims', 'sqcGroupNum', 'originalConsistenceAmt', 'originalVolumeAmt', 'originalSampleTypeName', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'consistenceAmt', 'actualConsistenceAmt', 'volumeAmt', 'actualVolumeAmt', 'totalAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt', 'positionInTmpBox', 'rnaIsPurification', 'rinValue', 'condenseConsistenceAmt', 'condenseVolumeAmt', 'condenseTotalAmt', 'hydrateVolumeAmt', 'dnaConsistenceAmt', 'dnaVolumeAmt', 'dnaTotalAmt', 'purificationConsistenceAmt', 'purificationVolumeAmt', 'pcrUsedTotalAmt', 'loopNum', 'amplificationRatio', 'noOfRoundLabels', 'noOfLongLabels'],
        sequencingPreResult: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'fragmentLen', 'actualFragmentLen', 'molarConcentration', 'actualMolarConcentration', 'originalSampleTypeName', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'consistenceAmt', 'actualConsistenceAmt', 'volumeAmt', 'actualVolumeAmt', 'totalAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt', 'positionInTmpBox', 'rnaIsPurification', 'rinValue', 'condenseConsistenceAmt', 'condenseVolumeAmt', 'condenseTotalAmt', 'hydrateVolumeAmt', 'dnaConsistenceAmt', 'dnaVolumeAmt', 'dnaTotalAmt', 'purificationConsistenceAmt', 'purificationVolumeAmt', 'pcrUsedTotalAmt', 'loopNum', 'amplificationRatio', 'noOfRoundLabels', 'noOfLongLabels'],
        sequencingResults: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'adjustedConcentrationRatio', 'addedVolumeAmt', 'seqReadLen', 'molarConcentration', 'actualMolarConcentration', 'indexSeqDigits', 'actualLaneNum', 'actualSeqTime', 'seqUsedVolumeAmt', 'originalSampleTypeName', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'consistenceAmt', 'actualConsistenceAmt', 'volumeAmt', 'actualVolumeAmt', 'totalAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt', 'positionInTmpBox', 'rnaIsPurification', 'rinValue', 'condenseConsistenceAmt', 'condenseVolumeAmt', 'condenseTotalAmt', 'hydrateVolumeAmt', 'dnaConsistenceAmt', 'dnaVolumeAmt', 'dnaTotalAmt', 'purificationConsistenceAmt', 'purificationVolumeAmt', 'pcrUsedTotalAmt', 'loopNum', 'amplificationRatio', 'noOfRoundLabels', 'noOfLongLabels'],
        GeneSchedule: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'originalSampleTypeName', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'consistenceAmt', 'actualConsistenceAmt', 'volumeAmt', 'actualVolumeAmt', 'totalAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt', 'positionInTmpBox', 'rnaIsPurification', 'rinValue', 'condenseConsistenceAmt', 'condenseVolumeAmt', 'condenseTotalAmt', 'hydrateVolumeAmt', 'dnaConsistenceAmt', 'dnaVolumeAmt', 'dnaTotalAmt', 'purificationConsistenceAmt', 'purificationVolumeAmt', 'pcrUsedTotalAmt', 'loopNum', 'amplificationRatio', 'noOfRoundLabels', 'noOfLongLabels'],
        GeneResults: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'originalSampleTypeName', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'consistenceAmt', 'actualConsistenceAmt', 'volumeAmt', 'actualVolumeAmt', 'totalAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt', 'positionInTmpBox', 'rnaIsPurification', 'rinValue', 'condenseConsistenceAmt', 'condenseVolumeAmt', 'condenseTotalAmt', 'hydrateVolumeAmt', 'dnaConsistenceAmt', 'dnaVolumeAmt', 'dnaTotalAmt', 'purificationConsistenceAmt', 'purificationVolumeAmt', 'pcrUsedTotalAmt', 'loopNum', 'amplificationRatio', 'noOfRoundLabels', 'noOfLongLabels'],
        expMgmtResults: ['sortNo', 'sampleIdLims', 'sampleIdLab', 'originalSampleTypeName', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'consistenceAmt', 'actualConsistenceAmt', 'volumeAmt', 'actualVolumeAmt', 'totalAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt', 'positionInTmpBox', 'rnaIsPurification', 'rinValue', 'condenseConsistenceAmt', 'condenseVolumeAmt', 'condenseTotalAmt', 'hydrateVolumeAmt', 'dnaConsistenceAmt', 'dnaVolumeAmt', 'dnaTotalAmt', 'purificationConsistenceAmt', 'purificationVolumeAmt', 'pcrUsedTotalAmt', 'loopNum', 'amplificationRatio', 'noOfRoundLabels', 'noOfLongLabels'],
        expMgmtSchedule: ['sortNo', 'sampleIdLims', 'ddpcrUsedVolumeAmt', 'ddpcrUsedTotalAmt', 'totalOilDrop', 'famSigOilDrop', 'hexSigOilDrop', 'resultAssessment', 'sampleIdLab', 'originalSampleTypeName', 'sampleTypeName', 'resultCount', 'resultSampleTypeName', 'srInstrucitons', 'sampleAmt', 'nextStepName', 'submittedByName', 'submittedByDate', 'noOfLabels', 'stoppedReason', 'remarks', 'actualSampleAmt', 'samplePkgAmt', 'actualSamplePkgAmt', 'remainingSampleAmt', 'remainingSamplePkgAmt', 'optProject', 'parallelProject', 'fTSampleDesc', 'fTSampleUvDesc', 'mergedSampleIdLims', 'storageName', 'positionInBox', 'consistenceAmt', 'actualConsistenceAmt', 'volumeAmt', 'actualVolumeAmt', 'totalAmt', 'actualTotalAmt', 'usedVolumeAmt', 'usedTotalAmt', 'remainingVolumeAmt', 'remainingTotalAmt', 'positionInTmpBox', 'rnaIsPurification', 'rinValue', 'condenseConsistenceAmt', 'condenseVolumeAmt', 'condenseTotalAmt', 'hydrateVolumeAmt', 'dnaConsistenceAmt', 'dnaVolumeAmt', 'dnaTotalAmt', 'purificationConsistenceAmt', 'purificationVolumeAmt', 'pcrUsedTotalAmt', 'loopNum', 'amplificationRatio', 'noOfRoundLabels', 'noOfLongLabels']
      }
    }
  },
  methods: {
    clearSearchCtrlF (tableDataNew, step) {
      const searchProps = [...this.stepSearchProps[step]]
      tableDataNew.map(row => {
        const item = row
        searchProps.forEach(key => {
          item[key + 'Match'] = false
        })
      })
    },
    filterNameChange () {
      this.currentIndex = 0
    },
    searchCtrlF (tableDataNew, step, tableName) {
      var columns = this.$refs[tableName].getColumns()
      var searchPropsArr = []
      columns.map(item => {
        if (this.columnShow.indexOf(item.property) > -1) {
          searchPropsArr.push(item.property)
        }
      })
      this.stepSearchProps[step] = searchPropsArr
      var tableDataNew1 = tableDataNew || this.tableData
      var filterName = XEUtils.toString(this.filterName).trim().toLowerCase()
      if (step == 'libquantSchedule' && tableName == 'xTable1') {
        filterName = XEUtils.toString(this.filterName1).trim().toLowerCase()
      }
      if (step == 'libquantResults' && tableName == 'xTable') {
        filterName = XEUtils.toString(this.filterName1).trim().toLowerCase()
      }
      if (filterName) {
        const searchProps = [...this.stepSearchProps[step]]
        // const rest = this.tableData1.filter(item => searchProps.some(key => XEUtils.toString(item[key]).toLowerCase().indexOf(filterName) > -1))
        // var firstMatch = false
        var currentMatchIndex = 0
        tableDataNew1.map((item, rowIndex) => {
          searchProps.forEach(key => {
            item[key + 'MatchCurrent'] = false
            if (XEUtils.toString(item[key]).toLowerCase().indexOf(filterName) > -1) {
              item[key + 'Match'] = true
              if (currentMatchIndex == this.currentIndex) {
                this.scrollToFirstMatch(item, key, rowIndex, tableName)
                item[key + 'MatchCurrent'] = true
              }
              // firstMatch = true
              currentMatchIndex += 1
            } else {
              item[key + 'Match'] = false
            }
          })
        })

        if (currentMatchIndex == 0) {
          this.$message('未找到匹配项')
          return
        }
        this.currentIndex += 1
        this.currentIndex = this.currentIndex % (currentMatchIndex)
      } else {
        this.clearSearchCtrlF(tableDataNew, step)
      }
    },
    scrollToFirstMatch (row, columnKey, rowIndex, tableName) {
      var column = this.$refs[tableName].getColumnByField(columnKey)
      // this.refs[this.tableName].scrollToColumn(columnKey)
      // var getRowById
      this.$refs[tableName].updateData().then(res => {
        this.$refs[tableName].scrollToRow(row, column)
        // this.$nextTick(() => {
        //   this.$refs[tableName].scrollToRow(row, column).then(res => {
        //     this.$refs[tableName].scrollToColumn(column)
        //   })
        // })

        // this.$refs[tableName].scrollToColumn(column)
      })
    }
  }
}
export default mixinMethod
